package com.prlab.idpserver.controller;

import com.prlab.idpserver.model.IdentityRequest;
import org.apache.tomcat.util.buf.HexUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.util.Base64Utils;
import org.springframework.web.bind.annotation.*;

import javax.crypto.*;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.sql.Types;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/api")
public class RESTfulApi {

	@Autowired
	JdbcTemplate jdbcTemplate = new JdbcTemplate();
	Logger logger = LoggerFactory.getLogger(RESTfulApi.class);


	@PostMapping("/idp/askIdentity")
	public String queryIdentity(@RequestBody IdentityRequest identityRequest) throws NoSuchAlgorithmException, NoSuchPaddingException, InvalidKeyException, InvalidAlgorithmParameterException, IllegalBlockSizeException, BadPaddingException {
		String sql = "SELECT * FROM identities WHERE HMACbase64 LIKE ?;";
		List<Map<String, Object>> list =  jdbcTemplate.queryForList(sql,new Object[]{identityRequest.HMAC +"%"}, new int[]{Types.VARCHAR});
		logger.info("identityRequest : {}, {}", identityRequest.HMAC, identityRequest.Cx);
		Cipher aesCipher = Cipher.getInstance("AES/CBC/NoPadding");
		IvParameterSpec IV = new IvParameterSpec(new byte[]{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00});

		logger.info("encryptedCx in base64 form : "+identityRequest.Cx);
		for(Map<String, Object> map : list){
			byte[] sharedSecret = (byte[])map.get("SharedSecret");
			byte[] Cx = (byte[])map.get("Cx");
			String IDx = (String)map.get("IDx");
			SecretKey secretKey = new SecretKeySpec(sharedSecret, "AES");
			logger.info("IDx in db : " + IDx);
			logger.info("sharedSecret in db : " + HexUtils.toHexString(sharedSecret));
			logger.info("Cx in db : " + HexUtils.toHexString(Cx));

			aesCipher.init(Cipher.DECRYPT_MODE, secretKey, IV);
			byte[] encryptedCx = Base64Utils.decodeFromString(identityRequest.Cx);
			logger.info("encryptedCx : " + HexUtils.toHexString(encryptedCx));
			byte[] decryptedCx = aesCipher.doFinal(encryptedCx, 0, 16);
			logger.info("decryptedCx : " + HexUtils.toHexString(decryptedCx));

			if(Arrays.equals(Cx, decryptedCx)){
				return IDx;
			}
		}
		return "None";
	}
}
